<?php

namespace app\controllers;

use Yii;
use app\models\Evaluationincentive;
use app\models\EvaluationincentiveSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\filters\AccessControl; 
use app\models\Attandance;
use app\models\Applicationsettings;
use app\models\Hivlinkage;
use app\models\Screening;
use app\base\Converter;

/**
 * EvaluationincentiveController implements the CRUD actions for Evaluationincentive model.
 */
class EvaluationincentiveController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['error'],
                        'allow' => true,
                    ],
                    [
                        'actions' => ['index', 'create', 'update', 'view', 'delete','visit','appset'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Evaluationincentive models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new EvaluationincentiveSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Evaluationincentive model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Evaluationincentive model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Evaluationincentive();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->evaluation_incentive_id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Evaluationincentive model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->evaluation_incentive_id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Evaluationincentive model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['/'.Yii::$app->controller->id]);
    }

    /**
     * Finds the Evaluationincentive model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Evaluationincentive the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Evaluationincentive::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
	
	public function actionVisit()
    {
        Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        $request = Yii::$app->request;
        if ($request->isGet)
            $id = $request->get('pid');
        if ($request->isPost)
            $id = $request->post('pid');
		$today = strtotime(date("Y/m/d"));
		
        $model = Attandance::find()->where(["participant_id" => $id])->andWhere(["=", "visit", -4])->andWhere(["record_date" => $today])->orderBy(['record_date' => SORT_DESC])->one();
		if ($model !== null) {	
         return $model;
		} 
    }
	
		
	public function actionAppset()
    {
		Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
        $request = Yii::$app->request;
        if ($request->isPost)
          //  $id = $request->post('id');

        $model = Applicationsettings::find()->orderBy("create_time DESC")->one();
        if ($model !== null) {		
          return $model;
		 // return $model->app_control_site;
			
        } 
    }
	/*
	public function actionHivlink()
	{
	   Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
    
        $request = Yii::$app->request;
	     if ($request->isPost)
            $id = $request->post('id');

        //$model = Screening::find()->where(["mem_scrn_part_id" => $id])->orderBy("create_time DESC")->one();
		$model =Hivlinkage::find()->where(["hiv_linkage_part_id" => $id])->orderBy("create_time DESC")->one();
		$res = $model;		
		if ($model !== null) {	         	
	      return $model;             	   
        } 	
		
    }
	
	public function actionScr()
	{
	   Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
    
        $request = Yii::$app->request;
	     if ($request->isPost)
            $id = $request->post('id');

        $smodel = Screening::find()->where(["mem_scrn_part_id" => $id])->orderBy("record_date DESC")->one();
		$hmodel =Hivlinkage::find()->where(["hiv_linkage_part_id" => $id])->orderBy("create_time DESC")->one();
	   	
		if($smodel !== null && $hmodel !== null && $hmodel->hiv_linkage_q6 !== '') {	   
           if(Converter::toStore($hmodel->hiv_linkage_q6) >= $smodel->record_date) {		  
	        return "1"; 			 
           }	
         else {
		  return "0"; 	   
          }   
        } 
		
		else {
		  return "0";
		}
       
		
    }
	*/
}
